#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <setupapi.h>
#include <devguid.h>
#include <ntddstor.h>
#include <winioctl.h>

int main(int argc, char **argv)
{
	int devidx, ifidx;
	HDEVINFO devset;
	SP_DEVINFO_DATA devdata;
	SP_DEVICE_INTERFACE_DATA devif;
	SP_DEVICE_INTERFACE_DETAIL_DATA_A *devdetail;
	DWORD size;
	DWORD regtype;
	char devname[1024];

	if((devset = SetupDiGetClassDevs(&GUID_DEVINTERFACE_DISK, 0, 0,
					DIGCF_PRESENT | DIGCF_DEVICEINTERFACE)) == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "failed to enumerate devices\n");
		return 1;
	}

	devidx = 0;
	for(;;) {
		memset(&devdata, 0, sizeof devdata);
		devdata.cbSize = sizeof devdata;
		if(!SetupDiEnumDeviceInfo(devset, devidx, &devdata)) {
			if(GetLastError() == ERROR_NO_MORE_ITEMS) break;
			devidx++;
			continue;
		}

		regtype = SPDRP_PHYSICAL_DEVICE_OBJECT_NAME;
		SetupDiGetDeviceRegistryProperty(devset, &devdata, SPDRP_FRIENDLYNAME,
				&regtype, (unsigned char*)devname, sizeof devname, &size);

		printf("Device %d: %s\n", devidx, devname);

		ifidx = 0;
		for(;;) {
			memset(&devif, 0, sizeof devif);
			devif.cbSize = sizeof devif;
			if(!SetupDiEnumDeviceInterfaces(devset, &devdata, &GUID_DEVINTERFACE_DISK, ifidx, &devif)) {
				if(GetLastError() == ERROR_NO_MORE_ITEMS) break;
				ifidx++;
				continue;
			}

			SetupDiGetDeviceInterfaceDetail(devset, &devif, 0, 0, &size, 0);
			if(!(devdetail = malloc(size))) {
				fprintf(stderr, "failed to allocate device interface detail buffer (size: %lu)\n", (unsigned long)size);
				return 1;
			}
			devdetail->cbSize = sizeof *devdetail;
			SetupDiGetDeviceInterfaceDetail(devset, &devif, devdetail, size, 0, 0);
			printf("  path: %s\n", devdetail->DevicePath);
			free(devdetail);

			ifidx++;
		}

		devidx++;
		printf("found %d devices\n", devidx);
	}
	return 0;
}
